<?php

require "include/bittorrent.php";

dbconn(false);
stdhead();
?>
<table class=main width=750 border=0 cellspacing=0 cellpadding=0><tr><td class=embedded>
<h2>Most common reasons for stats not updating</h2>
<table width=100% border=1 cellspacing=0 cellpadding=10><tr><td class=text> 

<b> The user is cheating.</b><br>
<br>
No explanation is needed...<br>
<br>
<br>
<b>The user is not using the client properly.</b><br>
<br>
Improper shutdown of the client is the most common cause. No information gets sent back to the tracker.<br>
<br>
<br>
<b>The user is using a client that is not compatible with the tracker, e.g.</b><br>
<br>
 BitTorrent++<br>
 Nova Torrent<br>
 TorrentStorm<br>
<br>
These clients do not report back to the tracker with the all important event=completed<br>
<br>
<br>
<b> The user is confusing the tracker by logging in to torrentbits with one IP,<br>
while downloading and/or uploading with another IP, either by;</b><br>
<br>
 Using more than one PC on the torrentbits.org site, or<br>
 Changing IP on the same PC or<br>
 Using a dual modem configuration, causing a double IP address<br>
<br>
This will again cause a misreporting of the event=completed<br>
<br>
<br>
<b>The user is disconnected from the tracker but any means, other than by properly closing the client, e.g.</b><br>
<br>
 PC crash<br>
 Power cut<br>
 ISP cut-offs due to time-outs, etc...<br>
<br>
No information gets sent back to the tracker<br>
<br>
<br>
<b>The user closes the client while the site is down.</b><br>
<br>
The client has nowhere to send the information to.<br>
<br>
<br>
<b>The user has not "finished" the torrent, stats dont update until you stop the torrent on most clients.</b><br>
<br>
The client has not yet sent event=completed back to the tracker.
<br>
</td></tr></table>
</td></tr></table>
<br>
<table class=main width=750 border=0 cellspacing=0 cellpadding=0><tr><td class=embedded>
<h2>Best practices</h2>
<table width=100% border=1 cellspacing=0 cellpadding=10><tr><td class=text> 

<ul><li>If a torrent you're currently leeching/seeding isn't listed on your profile, just wait or force a manual update.
<li>Make sure you exit your client properly, so that the tracker receives "event=completed".
<li>If the tracker is down, don't stop seeding. As long as the tracker is back up when you exit the client the total stats should update properly.<br>
Reciprocally, if you're about to close a torrent that you've seeded for a long time make sure the tracker is up before doing so.
<li>If you want to login from a second computer (work, school,...) create a second account.<br>
(A possible exception would be two computers behind the same NAT router.)
<br>
</td></tr></table>
</td></tr></table>
<br>
<table class=main width=750 border=0 cellspacing=0 cellpadding=0><tr><td class=embedded>
<h2>Why is a torrent I'm leeching/seeding listed several times in my profile?</h2>
<table width=100% border=1 cellspacing=0 cellpadding=10><tr><td class=text> 

If for some reason your client exits improperly and you restart it, it will have a new peer_id, so it will show as a new torrent. The old
one will never receive a "event=completed" or "event=stopped" and will be listed until some timeout. Just ignore it, it will eventually go away. 
<br>
</td></tr></table>
</td></tr></table>
<br>
<table class=main width=750 border=0 cellspacing=0 cellpadding=0><tr><td class=embedded>
<h2>Multiple IPs (Can I login from different computers?) </h2>
<table width=100% border=1 cellspacing=0 cellpadding=10><tr><td class=text> 

The IP address associated
with your account is the one from the computer where you last logged in from (either interactively or via
cookies). So if you're seeding in one computer and login from another the torrents from the first will no
longer be visible. This doesn't mean they're lost, as long as you login again from the first computer before
exiting the client the first IP will again be associated with your account at the event=completed time and
the total stats should update. The best practice, as stated exhaustively elsewhere, is to have different
accounts for different computers.
<br>
</td></tr></table>
</td></tr></table>
<br>
<table class=main width=750 border=0 cellspacing=0 cellpadding=0><tr><td class=embedded>
<h2>Anatomy of a torrent session </h2>
<table width=100% border=1 cellspacing=0 cellpadding=10><tr><td class=text> 

There seems to be a lot of confusion about how the statistics updates work. The following is a capture of a full
session to see what's going on behind the scenes. The client communicates with the tracker via simple http GET commands. The very first in this case was:<br>
<br>
<code>GET /announce.php?info_hash=c%97%91%C5jG%951%BE%C7M%F9%BFa%03%F2%2C%ED%EE%0F& peer_id=S588-----gqQ8TqDeqaY&port=6882&uploaded=0&downloaded=0&left=753690875 &event=started</code><br>
<br>
Let's dissect this:<br>
<br>
 <b>info_hash</b> is just the hash identifying the torrent in question;<br>
 <b>peer_id</b>, as the name suggests, identifies the client (the s588 part identifies Shad0w's 5.8.8, the rest is random);<br>
 <b>port</b> just tells the tracker which port the client will listen to for incoming connections;<br>
 <b>uploaded</b>=0; (this and the following are the relevant ones, and are self-explanatory)<br>
 <b>downloaded</b>=0;<br>
 <b>left</b>=753690875 (how much left); <br>
 <b>event=started</b> (telling the tracker that the client has just started).<br>
<br>
Notice that the client IP doesn't show up here. It's up to the tracker to see it and associate it with the user_id.<br>
(Server replies will be omitted, they're just lists of peer ips and respective ports.)<br>
At this stage the profile will be listing this torrent as being leeched.<br>
<br>
From now on the client will keep send GETs to the tracker. We show only the first one as an example,
<br>
<br>
<code> GET /announce.php?info_hash=c%97%91%C5jG%951%BE%C7M%F9%BFa%03%F2%2C%ED%EE%0F& peer_id=S588-----gqQ8TqDeqaY&port=6882&uploaded=67960832&downloaded=40828928& left=715417851&numwant=0</code><br>
<br>
("numwant" is how the client tells the tracker how many new peers it wants, in this case 0.)
<br>
<br>
As you can see at this stage the user had uploaded approx. 68MB and downloaded approx. 40MB. Whenever the tracker receives
these GETs it updates the stats relative to the 'currently leeching/seeding' boxes. It will <b>not</b>
update the total stats at this stage. These intermediate GETs will be sent either periodically (every 12 min
or so, depends on the client) or when you force a manual announce in the client.
<br>
<br>
Finally, when the client was closed it sent
<br>
<br>
<code> GET /announce.php?info_hash=c%97%91%C5jG%951%BE%C7M%F9%BFa%03%F2%2C%ED%EE%0F& peer_id=S588-----gqQ8TqDeqaY&port=6882&uploaded=754384896&downloaded=754215163 &left=0&numwant=0&event=completed</code><br>
<br>
Notice the all-important "event=completed". It is only at this stage that the total stats will be updated.
If for some reason (tracker down, lost connection, bad client, crash, ...) this last GET doesn't reach
the tracker the stats for this torrent will be lost. It should be stressed that this message will be sent only when
closing the client properly, not when the download is finished. (The tracker will start listing
a torrent as 'currently seeding' after it receives a GET with left=0). <br>
<br>
There's a further message that causes the total stats to be updated, namelly "event=stopped". This is usually sent 
when stopping in the middle of a download, e.g. by pressing 'Cancel' in Shad0w's. <br>
<br>
One last note: some clients have a pause/resume option. This will <b>not</b> send any message to the server. 
Do not use it as a way of updating stats, it just doesn't work. (Checked for Shad0w's 5.8.8 and ABC 2.6.2.)
<br>
</td></tr></table>
</td></tr></table>
<br>
<?
stdfoot();
?>